#include <time.h>
#include <stdlib.h>
#include <qdos.h>
#include <stdio.h>

char _prog_name[]="partial screen 2 sprite (basic)";
char _version[]="1.0";
char _copyright[]="Absolutly Free";

void (*_consetup)()=consetup_title;
main(argc,argv)
char argc;
char **argv;
{
FILE *in,*out;
unsigned short line=10;
unsigned char *buffer;
short height,width,i,j,k,l;
if (argc!=4) {printf("Usage : %s in_blk out_bas name\n\tin_blk is a partial screen block file\n\tout_bas is a sprite definition in basic\n\tname : name of the sprite",argv[0]); exit(0);}

in=fopene(argv[1],"r",1); /* search data then prog directory */
if (!in) {printf("Input file : not found\n"); exit(0);}

out=fopen(argv[2],"w"); /* in data directory, default */
if (!out) {printf("Output file : Error (Cannot open)\n"); exit(0);}
fread(&width,2,1,in);
fread(&height,2,1,in);
buffer=malloc(width*height/4); /* Width x Heigth : 8 pixel per 2 bytes */
if (!buffer) {
   fclose(in);
   fclose(out);
   printf("Run out of allocable memory...\n"); exit(0);
   }
fprintf(out,"%d REMark Sprite %s   Mode 4\n",line++,argv[3]);
fprintf(out,"%d DATA %d,%d,0,0,4\n",line++,height,width);
fread(buffer,width*height/4,1,in);
for(k=0,j=0;j<height;j++)
{
fprintf(out,"%d DATA '",line++);
for(i=0;i<width/8;i++,k++)
{char red,green,c,a,b;
red=buffer[2*k];
green=buffer[2*k+1];
for(l=0;l<8;l++)
{
a=0x01&(red>>(7-l));
b=0x01&(green>>(7-l));
switch (a+2*b){
case 0: c='a'; break;
case 1: c='r'; break;
case 2: c='g'; break;
case 3: c='w'; break;
default: c=' '; break;
}
fprintf(out,"%c",c);
}
}
fprintf(out,"'\n");
}
fprintf(out,"%d rem *^*\n",line++);
fprintf(out,
"%d REMark * Automatically Created Sprite From Part of Picture\n%d REMark * Program by Jrme Grimbert (QLCF 189)\n%d REMark * Freely available\n",++line,++line,++line);
fclose(in);
fclose(out);

}
